#include "server.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main() {
    char* name = "test";
    int num_records = 100;
    int page_size = 1024;
    IdxState *idxState = NULL;
    TxnState *txnState = NULL;

    int errCode;

    if ((errCode = create(INT, name, page_size)) != SUCCESS) {
        printf("could not create index\n");
        return EXIT_FAILURE;
    }

    if ((errCode = openIndex(name, &idxState)) != SUCCESS) {
        printf("can't open index\n");
        return EXIT_FAILURE;
    }

    if ((errCode = beginTransaction(&txnState)) != SUCCESS) {
        printf("Could not begin transaction!\n");
        return EXIT_FAILURE;
    }

    ErrCode err_i;
    Key key;
    key.type = INT;
    for (int i = 0; i < num_records; ++i) {
        key.keyval.intkey = i;

        char pld[8];

        if (i < 10) {
            sprintf(pld, "value0%d", i);
        } else {
            sprintf(pld, "value%d", i);
        }

        err_i = insertRecord(idxState, NULL, &key, pld);
        if (err_i != SUCCESS) {
            printf("Key %lld could not be inserted!\n", key.keyval.intkey);
            return EXIT_FAILURE;
        }
    }

    if ((errCode = closeIndex(idxState)) != SUCCESS) {
        printf("could not close index\n");
        return EXIT_FAILURE;
    }
}